org.eclnt.workplace

## Class Workpage

- java.lang.Object
- - org.eclnt.workplace.Workpage

- All Implemented Interfaces:
    java.io.Serializable, IWorkpage
  Direct Known Subclasses:
    WorkpageByPageBean

      public class Workpage
      extends java.lang.Object
      implements java.io.Serializable, IWorkpage

  Default implementation of IWorkplage interface. Must be used as base for own implementations.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Workpage(IWorkpageDispatcher dispatcher, java.lang.String jspPage, java.lang.String id, java.lang.String title, java.lang.String iconURL, boolean isDecorated)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLifecycleListener(IWorkpageLifecycleListener listener)`
    `void` | `addWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)`
    `void` | `assignIdToModelessPopup(ModelessPopup popup, java.lang.String id)`
    `boolean` | `close()` Asks all life cycle listeners - if one does not want to close then the whole close is interrupted.
    `boolean` | `closeAndContinue(java.lang.Runnable continueOperation)` Same processing as with `close()` - but now passing the continueOperation in addition.
    `void` | `closeForced()` Default behaviour: the dispatcher gets destroyed.
    `void` | `closeSemiModalPopup(IPageBean callingPageBean, IPageBean popupPageBean)` Close popup that was opened via `#openSemiModalPopup(IPageBean, String, int, int, org.eclnt.jsfserver.defaultscreens.ModelessPopup.IModelessPopupListener)`.
    `ModalPopup` | `createModalPopupInWorkpageContext()` Creates a modal popup that runs in the context of the workpage.
    `ModelessPopup` | `createModelessPopupInWorkpageContext()` Creates a modeless popup that runs in the context of the workpage.
    `java.lang.String` | `getComment()` Comment - the comment is e.g. shown in tool tips.
    `IWorkpageDispatcher` | `getDispatcher()` Each workpage is associated with a dispatcher that manages the managed beans for this workpage.
    `java.lang.String` | `getDragsend()`
    `boolean` | `getExcludeFromSavePerspective()` The workplace perspective management allows to store currently opened workplace arrangements as perspectives.
    `java.lang.String` | `getIconURL()` The icon of the workpage that is shown in the task overview.
    `java.lang.String` | `getId()` Each workpage specifies an id.
    `java.lang.String` | `getJspPage()` This is the start page of the workpage.
    `java.util.Set<IWorkpageLifecycleListener>` | `getLifecycleListeners()`
    `ModelessPopup` | `getModelesspopup(java.lang.String assignedId)`
    `ModelessPopup` | `getModelessPopupOfWorkpage()` A workpage may be opened as modeless popup.
    `java.lang.String` | `getParam(java.lang.String paramName)`
    `java.util.Map<java.lang.String,java.lang.String>` | `getParamMap()`
    `java.lang.String` | `getSelectorTitle()` The text that is shown inside the selector for the workpage.
    `java.lang.String` | `getSelectorTitleOriginal()`
    `java.lang.String` | `getStartSubWorkpageContainerId()`
    `java.lang.String` | `getTitle()` The title of the workpage.
    `java.lang.String` | `getUniqueTechnicalId()` Each workpage provides a technical id that is unique across all work pages.
    `IWorkpageContainer` | `getWorkpageContainer()` Returns the container this workpage is living in.
    `IWorkpageStartInfo` | `getWorkpageStartInfo()`
    `boolean` | `isBlocked()` Managed at runtime by workplace management: if a page opens up semi modal popup dialogs then the page need to be blocked.
    `boolean` | `isCloseSupported()` Indicates if the workpage can be closed via a close icon.
    `boolean` | `isDecorated()` Indicates if the workplace embeds the workpage into a frame with titlebar etc.
    `boolean` | `isPopupSupported()` Indicates if the workpage can be isolated from the workpage container into a modal popup.
    `ModelessPopup` | `openSemiModalPopup(IPageBean callingPageBean, IPageBean popupPageBean, java.lang.String title, int width, int height, ModelessPopup.IModelessPopupListener popupListener)` Opens a modal popup which is only modal in the optical scope of the workpage.
    `void` | `processWorkpageProcessingEvent(WorkpageProcessingEvent event)` Process workpage processing event coming from other workpage.
    `boolean` | `reactOnBeforeHide()` This method is called before the workpage gets hidden e.g. due to user selection in the workpage selector.
    `void` | `reactOnDisplay()` This method is called whenever the workpage container is pushing this page to be displayed.
    `void` | `reactOnHide()` This method is called whenever a workpage that is currently shown within in the content area is replaced by another one.
    `void` | `reactOnReselectedInContentArea()` This method is called if the workpage is currently shown in its workpage container - and if the user re-selects the workpage.
    `void` | `reactOnShownInContentArea()` The page is (re)shown in the content area of the workplace.
    `void` | `reactOnShownInPopup()` The page is (re)shown in a modeless popup.
    `void` | `removeLifecycleListener(IWorkpageLifecycleListener listener)`
    `void` | `removeWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)`
    `void` | `setCloseSupported(boolean closeSupported)` Controls if the workpage provides a close icond within its title area.
    `void` | `setComment(java.lang.String comment)`
    `void` | `setDecorated(boolean value)`
    `void` | `setExcludeFromSavePerspective(boolean excludeFromSavePerspective)`
    `void` | `setIconURL(java.lang.String value)` Update the icon during runtime.
    `void` | `setId(java.lang.String value)` The id can be changed during runtime.
    `void` | `setJspPage(java.lang.String value)`
    `void` | `setModelessPopupOfWorkpage(ModelessPopup popup)` Function that allows WorkpageContainer to set ModelessPopup instance.
    `void` | `setParam(java.lang.String paramName, java.lang.String paramValue)`
    `void` | `setPopupSupported(boolean value)` Controls if the workpage is isolate-able as modeless popup by the user.
    `void` | `setSelectorTitle(java.lang.String value)` Update selector title during runtime.
    `void` | `setStartSubWorkpageContainerId(java.lang.String startSubWorkpageContainerId)`
    `void` | `setTitle(java.lang.String value)` Update title during runtime.
    `void` | `setWorkpageStartInfo(IWorkpageStartInfo workpageStartInfo)`
    `void` | `throwWorkpageProcessingEvent(WorkpageProcessingEvent event)` Throws an event and triggers the delegation of the event to all other workpage instances.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Workpage

          public Workpage(IWorkpageDispatcher dispatcher,
                          java.lang.String jspPage,
                          java.lang.String id,
                          java.lang.String title,
                          java.lang.String iconURL,
                          boolean isDecorated)

      Parameters:
        `dispatcher` - Dispatcher in that the workpage creates its own dispatcher. If the dispatcher passed is "#{d}" then the workpage will create a sub-dispatcher "#{d.d_1}" that will be used for the beans used within this workpage context.

  - ### Method Detail

    - #### getDragsend

          public java.lang.String getDragsend()

    - #### setWorkpageStartInfo

          public void setWorkpageStartInfo(IWorkpageStartInfo workpageStartInfo)

      Specified by:
        `setWorkpageStartInfo` in interface `IWorkpage`

    - #### getWorkpageStartInfo

          public IWorkpageStartInfo getWorkpageStartInfo()

      Specified by:
        `getWorkpageStartInfo` in interface `IWorkpage`

    - #### getDispatcher

          public IWorkpageDispatcher getDispatcher()

      Description copied from interface: `IWorkpage`
      Each workpage is associated with a dispatcher that manages the managed beans for this workpage. This is the dispatcher of the workpage.
      Please note: there is a dispatcher hierarchy - a top dispatcher ("#{d}") and there are sub-dispatchers, one for each workpage instance ("#{d.d_x}"). The dispatcher that is returned by this method is the workpage instance ("#{d.d_x}").
      Specified by:
        `getDispatcher` in interface `IWorkpage`
      Returns:
        The dispatcher that is associated with this workpage. Pay attentions: this is NOT the dispatcher passed via the constructor but this is a sub-dispatcher of this dispatcher.

    - #### setId

          public void setId(java.lang.String value)

      Description copied from interface: `IWorkpage`
      The id can be changed during runtime.
      Specified by:
        `setId` in interface `IWorkpage`

    - #### getId

          public java.lang.String getId()

      Description copied from interface: `IWorkpage`
      Each workpage specifies an id. The id is used to check if a workpage is already included in a workpage container or not. The id needs to uniquely identify the workpage with its content.
      Specified by:
        `getId` in interface `IWorkpage`

    - #### setTitle

          public void setTitle(java.lang.String value)

      Description copied from interface: `IWorkpage`
      Update title during runtime.
      Specified by:
        `setTitle` in interface `IWorkpage`

    - #### getTitle

          public java.lang.String getTitle()

      Description copied from interface: `IWorkpage`
      The title of the workpage.
      Specified by:
        `getTitle` in interface `IWorkpage`

    - #### setSelectorTitle

          public void setSelectorTitle(java.lang.String value)

      Description copied from interface: `IWorkpage`
      Update selector title during runtime.
      Specified by:
        `setSelectorTitle` in interface `IWorkpage`

    - #### getSelectorTitle

          public java.lang.String getSelectorTitle()

      Description copied from interface: `IWorkpage`
      The text that is shown inside the selector for the workpage. If returned as null then the normal title via `IWorkpage.getTitle()` is shown.
      Specified by:
        `getSelectorTitle` in interface `IWorkpage`

    - #### getSelectorTitleOriginal

          public java.lang.String getSelectorTitleOriginal()

    - #### setJspPage

          public void setJspPage(java.lang.String value)

    - #### getJspPage

          public java.lang.String getJspPage()

      Description copied from interface: `IWorkpage`
      This is the start page of the workpage.
      Specified by:
        `getJspPage` in interface `IWorkpage`

    - #### setIconURL

          public void setIconURL(java.lang.String value)

      Description copied from interface: `IWorkpage`
      Update the icon during runtime.
      Specified by:
        `setIconURL` in interface `IWorkpage`

    - #### getIconURL

          public java.lang.String getIconURL()

      Description copied from interface: `IWorkpage`
      The icon of the workpage that is shown in the task overview.
      Specified by:
        `getIconURL` in interface `IWorkpage`

    - #### setDecorated

          public void setDecorated(boolean value)

    - #### isDecorated

          public boolean isDecorated()

      Description copied from interface: `IWorkpage`
      Indicates if the workplace embeds the workpage into a frame with titlebar etc.
      Specified by:
        `isDecorated` in interface `IWorkpage`

    - #### getStartSubWorkpageContainerId

          public java.lang.String getStartSubWorkpageContainerId()

      Specified by:
        `getStartSubWorkpageContainerId` in interface `IWorkpage`

    - #### setStartSubWorkpageContainerId

          public void setStartSubWorkpageContainerId(java.lang.String startSubWorkpageContainerId)

    - #### close

          public boolean close()

      Asks all life cycle listeners - if one does not want to close then the whole close is interrupted. Calls closeForced() when all have agreed to close.
      Specified by:
        `close` in interface `IWorkpage`
      Returns:
        True if the closing was successful, false if not (e.g. if unsaved data would get destroyed).

    - #### closeAndContinue

          public boolean closeAndContinue(java.lang.Runnable continueOperation)

      Same processing as with `close()` - but now passing the continueOperation in addition.
      Specified by:
        `closeAndContinue` in interface `IWorkpage`

    - #### closeForced

          public void closeForced()

      Default behaviour: the dispatcher gets destroyed.
      Specified by:
        `closeForced` in interface `IWorkpage`

    - #### getWorkpageContainer

          public IWorkpageContainer getWorkpageContainer()

      Description copied from interface: `IWorkpage`
      Returns the container this workpage is living in.
      Specified by:
        `getWorkpageContainer` in interface `IWorkpage`

    - #### setPopupSupported

          public void setPopupSupported(boolean value)

      Controls if the workpage is isolate-able as modeless popup by the user.

    - #### isPopupSupported

          public boolean isPopupSupported()

      Description copied from interface: `IWorkpage`
      Indicates if the workpage can be isolated from the workpage container into a modal popup.
      Specified by:
        `isPopupSupported` in interface `IWorkpage`

    - #### setCloseSupported

          public void setCloseSupported(boolean closeSupported)

      Controls if the workpage provides a close icond within its title area.

    - #### isCloseSupported

          public boolean isCloseSupported()

      Description copied from interface: `IWorkpage`
      Indicates if the workpage can be closed via a close icon.
      Specified by:
        `isCloseSupported` in interface `IWorkpage`

    - #### reactOnDisplay

          public void reactOnDisplay()

      Description copied from interface: `IWorkpage`
      This method is called whenever the workpage container is pushing this page to be displayed.
      Specified by:
        `reactOnDisplay` in interface `IWorkpage`

    - #### setParam

          public void setParam(java.lang.String paramName,
                               java.lang.String paramValue)

      Specified by:
        `setParam` in interface `IWorkpage`

    - #### getParam

          public java.lang.String getParam(java.lang.String paramName)

      Specified by:
        `getParam` in interface `IWorkpage`

    - #### getParamMap

          public java.util.Map<java.lang.String,java.lang.String> getParamMap()

      Specified by:
        `getParamMap` in interface `IWorkpage`

    - #### addLifecycleListener

          public void addLifecycleListener(IWorkpageLifecycleListener listener)

      Specified by:
        `addLifecycleListener` in interface `IWorkpage`

    - #### removeLifecycleListener

          public void removeLifecycleListener(IWorkpageLifecycleListener listener)

      Specified by:
        `removeLifecycleListener` in interface `IWorkpage`

    - #### getLifecycleListeners

          public java.util.Set<IWorkpageLifecycleListener> getLifecycleListeners()

      Specified by:
        `getLifecycleListeners` in interface `IWorkpage`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### reactOnReselectedInContentArea

          public void reactOnReselectedInContentArea()

      Description copied from interface: `IWorkpage`
      This method is called if the workpage is currently shown in its workpage container - and if the user re-selects the workpage.
      Specified by:
        `reactOnReselectedInContentArea` in interface `IWorkpage`

    - #### reactOnShownInContentArea

          public void reactOnShownInContentArea()

      Description copied from interface: `IWorkpage`
      The page is (re)shown in the content area of the workplace.
      Specified by:
        `reactOnShownInContentArea` in interface `IWorkpage`

    - #### reactOnHide

          public void reactOnHide()

      Description copied from interface: `IWorkpage`
      This method is called whenever a workpage that is currently shown within in the content area is replaced by another one.
      Specified by:
        `reactOnHide` in interface `IWorkpage`

    - #### reactOnBeforeHide

          public boolean reactOnBeforeHide()

      Description copied from interface: `IWorkpage`
      This method is called before the workpage gets hidden e.g. due to user selection in the workpage selector.
      Specified by:
        `reactOnBeforeHide` in interface `IWorkpage`

    - #### reactOnShownInPopup

          public void reactOnShownInPopup()

      Description copied from interface: `IWorkpage`
      The page is (re)shown in a modeless popup.
      Specified by:
        `reactOnShownInPopup` in interface `IWorkpage`

    - #### throwWorkpageProcessingEvent

          public void throwWorkpageProcessingEvent(WorkpageProcessingEvent event)

      Description copied from interface: `IWorkpage`
      Throws an event and triggers the delegation of the event to all other workpage instances.
      Specified by:
        `throwWorkpageProcessingEvent` in interface `IWorkpage`

    - #### processWorkpageProcessingEvent

          public void processWorkpageProcessingEvent(WorkpageProcessingEvent event)

      Description copied from interface: `IWorkpage`
      Process workpage processing event coming from other workpage.
      Specified by:
        `processWorkpageProcessingEvent` in interface `IWorkpage`

    - #### addWorkpageProcessingEventListener

          public void addWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)

      Specified by:
        `addWorkpageProcessingEventListener` in interface `IWorkpage`

    - #### removeWorkpageProcessingEventListener

          public void removeWorkpageProcessingEventListener(IWorkpageProcessingEventListener listener)

      Specified by:
        `removeWorkpageProcessingEventListener` in interface `IWorkpage`

    - #### createModalPopupInWorkpageContext

          public ModalPopup createModalPopupInWorkpageContext()

      Description copied from interface: `IWorkpage`
      Creates a modal popup that runs in the context of the workpage.
      This method is deprecated because all popup dialog management should be done through page beans. It is still available for compatibility reasons.
      Specified by:
        `createModalPopupInWorkpageContext` in interface `IWorkpage`

    - #### createModelessPopupInWorkpageContext

          public ModelessPopup createModelessPopupInWorkpageContext()

      Description copied from interface: `IWorkpage`
      Creates a modeless popup that runs in the context of the workpage.
      This method is deprecated because all popup dialog management should be done through page beans. It is still available for compatibility reasons.
      Specified by:
        `createModelessPopupInWorkpageContext` in interface `IWorkpage`

    - #### assignIdToModelessPopup

          public void assignIdToModelessPopup(ModelessPopup popup,
                                              java.lang.String id)

      Specified by:
        `assignIdToModelessPopup` in interface `IWorkpage`

    - #### getModelesspopup

          public ModelessPopup getModelesspopup(java.lang.String assignedId)

      Specified by:
        `getModelesspopup` in interface `IWorkpage`

    - #### getModelessPopupOfWorkpage

          public ModelessPopup getModelessPopupOfWorkpage()

      Description copied from interface: `IWorkpage`
      A workpage may be opened as modeless popup. This function returns the popup instance the workpage is running in. In case the workplage does not run in a modeless popup, null will be returned.
      Specified by:
        `getModelessPopupOfWorkpage` in interface `IWorkpage`
      Returns:

    - #### setModelessPopupOfWorkpage

          public void setModelessPopupOfWorkpage(ModelessPopup popup)

      Description copied from interface: `IWorkpage`
      Function that allows WorkpageContainer to set ModelessPopup instance.
      Specified by:
        `setModelessPopupOfWorkpage` in interface `IWorkpage`

    - #### getUniqueTechnicalId

          public java.lang.String getUniqueTechnicalId()

      Description copied from interface: `IWorkpage`
      Each workpage provides a technical id that is unique across all work pages. The technical id is assigned internally and does not provide any application semantics!
      Specified by:
        `getUniqueTechnicalId` in interface `IWorkpage`

    - #### setExcludeFromSavePerspective

          public void setExcludeFromSavePerspective(boolean excludeFromSavePerspective)

    - #### getExcludeFromSavePerspective

          public boolean getExcludeFromSavePerspective()

      Description copied from interface: `IWorkpage`
      The workplace perspective management allows to store currently opened workplace arrangements as perspectives. The perspectives include the arrangement of workplace tiles - and the workpages that are currently started within the tile. - You can exclude the current workpage from being stored as part of a perspective by using this function.
      Specified by:
        `getExcludeFromSavePerspective` in interface `IWorkpage`

    - #### getComment

          public java.lang.String getComment()

      Description copied from interface: `IWorkpage`
      Comment - the comment is e.g. shown in tool tips.
      Specified by:
        `getComment` in interface `IWorkpage`

    - #### setComment

          public void setComment(java.lang.String comment)

    - #### isBlocked

          public boolean isBlocked()

      Description copied from interface: `IWorkpage`
      Managed at runtime by workplace management: if a page opens up semi modal popup dialogs then the page need to be blocked.
      Specified by:
        `isBlocked` in interface `IWorkpage`

    - #### openSemiModalPopup

          public ModelessPopup openSemiModalPopup(IPageBean callingPageBean,
                                                  IPageBean popupPageBean,
                                                  java.lang.String title,
                                                  int width,
                                                  int height,
                                                  ModelessPopup.IModelessPopupListener popupListener)

      Opens a modal popup which is only modal in the optical scope of the workpage. Other workpage can still be used.
      Specified by:
        `openSemiModalPopup` in interface `IWorkpage`
      Returns:

    - #### closeSemiModalPopup

          public void closeSemiModalPopup(IPageBean callingPageBean,
                                          IPageBean popupPageBean)

      Description copied from interface: `IWorkpage`
      Close popup that was opened via `#openSemiModalPopup(IPageBean, String, int, int, org.eclnt.jsfserver.defaultscreens.ModelessPopup.IModelessPopupListener)`.
      Specified by:
        `closeSemiModalPopup` in interface `IWorkpage`

Copyright © CaptainCasa Gmbh. All Rights Reserved.